// M1Object.js - LTD0

var localServer;
var fileServices;
var aggregator;
var synchronizer;
var timerID = 0;
var serverReady = false;
var cdsStatus = 'Starting Media Server...';

var monitorState = null;
var aggregateState = null;

var addServerArray = new Array;
var removeServerArray =  new Array;
var addFolderArray = new Array;
var removeFolderArray =  new Array;

var confirming = false;
var updating = false;

bodyContents += "<object id=\"MXMediaOne\" classid=\"CLSID:9D25FCBD-A450-43CD-9409-CEBDD09E9DD3\"></object>";
bodyContents += "<object id=\"Toolbox\" classid=\"CLSID:880135BF-07C6-4A4E-AF6E-46093AE8629C\"></object>";
bodyContents += "<div id=\"output\"></div>";
//parent.document.getElementById("pageFrame").src = "../content_mgr/home.htm";
bodyOnload[bodyOnload.length] = function() {StartMediaOne();};
bodyOnunload[bodyOnunload.length] = function() {StopMediaOne()};


////////////////////////////////////////////////////////////////////////////////
// Connection Manager object

var SERVICE_STOPPED              = 0x00000001;
var SERVICE_START_PENDING        = 0x00000002;
var SERVICE_STOP_PENDING         = 0x00000003;
var SERVICE_RUNNING              = 0x00000004;
var SERVICE_CONTINUE_PENDING     = 0x00000005;
var SERVICE_PAUSE_PENDING        = 0x00000006;
var SERVICE_PAUSED               = 0x00000007;


////////////////////////////////////////////////////////////////////////////////
// Connection manager manages service stopping, starting, and connecting
//
// Possible states (returned via getStatus()):
//  'stopped'      : service is stopped, we can't connect
//  'disconnected' : service is running, but we are not connected
//  'connecting'   : service is running, we are connecting
//  'connected'    : service is running and we are connected
//  'stopping'     : service is stopping, we are not connected
//  'starting'     : service is starting, we are not connected
//  'error'        : an error occurred
function ConnectionManager(objFrame)
{
  this.objFrame = objFrame;
  this.disconnect(); // ensure disconnected state
}

ConnectionManager.prototype.connect = function()
{
  if (this.objFrame.Toolbox.QueryServiceStatus() != SERVICE_STOPPED)
  {
    this.objFrame.MXMediaOne.start(); // flush discovery cache
    this.disconnect();
    ConnectionManager__connecting();
  }
}

ConnectionManager.prototype.restart = function()
{
  this.disconnect();
  ConnectionManager__stop();
}

ConnectionManager.prototype.disconnect = function()
{
  if (this.objFrame.localServer != null){
    this.objFrame.localServer.dispose();
    this.objFrame.localServer = null;
  }
  this.objFrame.fileServices = null;
  this.objFrame.aggregator = null;
  this.objFrame.synchronizer = null;
  
  this.status = 'disconnected'; 
}

ConnectionManager.prototype.getStatus = function()
{
  if (!this.isActive() && 
      this.objFrame.Toolbox.QueryServiceStatus() == SERVICE_STOPPED)
  {
    this.disconnect();
    this.status = 'stopped';
  } 
  return this.status;
}

ConnectionManager.prototype.isActive = function()
{
  return this.status == 'stopping' ||
    this.status == 'starting' ||
    this.status == 'connecting';
}

function ConnectionManager__connecting()
{
  try
  {
    parent.objFrame.connectionManager.status = 'connecting';
    parent.objFrame.localServer = parent.objFrame.MXMediaOne.localServer;
    if (parent.objFrame.localServer)
    {
      parent.objFrame.fileServices = 
          parent.objFrame.localServer.osServices.fileServices;
      parent.objFrame.aggregator = parent.objFrame.localServer.aggregator;
      parent.objFrame.synchronizer = parent.objFrame.localServer.synchronizer;
      if (parent.objFrame.fileServices && 
            parent.objFrame.aggregator && 
            parent.objFrame.synchronizer)
        {
          parent.objFrame.synchronizer.connectSync();
          parent.objFrame.aggregator.connectAgg();

          if (parent.objFrame.synchronizer.connected &&
              parent.objFrame.aggregator.connected)
          {
            parent.objFrame.connectionManager.status = 'connected';
            return;
          }
	}
      }
      // if our connection attempt fails, try again
      setTimeout("ConnectionManager__connecting()", 1000);
  }
  catch(ex)
  {
    parent.objFrame.connectionManager.status = 'error';
  } 
}

function ConnectionManager__stop()
{
  parent.objFrame.connectionManager.status = 'stopping';
  if (parent.objFrame.Toolbox.StopService())
  {
    setTimeout("ConnectionManager__stopping()", 500);
  }
  else
  {
    parent.objFrame.connectionManager.status = 'error';
  } 
}

function ConnectionManager__starting()
{
  try
  {
    parent.objFrame.connectionManager.status = 'starting';
    if (parent.objFrame.Toolbox.QueryServiceStatus() == SERVICE_RUNNING)
    {
      setTimeout("ConnectionManager__connecting()", 1000);
    }
    else
    {
      setTimeout("ConnectionManager__starting()", 500);
    }
  }
  catch(e)
  {
    parent.objFrame.connectionManager.status = 'error';
  }
}

function ConnectionManager__stopping()
{
  try
  {
    var status = parent.objFrame.Toolbox.QueryServiceStatus(); 
    if (status == SERVICE_STOPPED)
    {
      // service is stopped, re-start
      var success = false;
 
      // We'd also like to make sure the rest of the EF stack is up...
      try
      {
        var monitor = new ActiveXObject("IntelMediaServer.ServiceMonitor");
	    monitor.StartServices();
	    success = true;
      }
      catch(ex)
      {
        // An error occurred, starting the whole stack,
	    // let's at least get the media server going
        success = parent.objFrame.Toolbox.StartService();
      }

      if (success)
      {
        parent.objFrame.connectionManager.status = 'starting';
        setTimeout("ConnectionManager__starting()", 500);
      }
      else
      {
        parent.objFrame.connectionManager.status = 'error';
      } 
    }
    else
    {
      setTimeout("ConnectionManager__stopping()", 500);
    }
  }
  catch(e)
  {
    parent.objFrame.connectionManager.status = 'error';  
  }
}

function StartMediaOne()
{
  try
  {	
    debug_print("Starting MediaOne Service...");
    parent.objFrame.MXMediaOne.start();
    parent.objFrame.MXMediaOne.addFeatures(2);
    /** temporary hack to give time to discover. **/
    //timerID  = setTimeout(GetServer, 100);
 
    parent.objFrame.connectionManager = new ConnectionManager(parent.objFrame);
    parent.objFrame.connectionManager.connect();
  }
  catch(e)
  {
  	// LTD: What to do here?
  }
}


function StopMediaOne()
{
    //  if (timerID != 0)
    //clearTimeout(timerID);
  try
  {
      parent.objFrame.connectionManager.disconnect();
      if (parent.objFrame.localServer != null){
         parent.objFrame.localServer.dispose();
         parent.objFrame.localServer = null;
         parent.objFrame.fileServices = null;
         parent.objFrame.aggregator = null;
         parent.objFrame.synchronizer = null;
      }
      parent.objFrame.MXMediaOne.stop();
  }
  catch(e)
  {
  }
}

/////////////////////////////////////////////////////////////////
// Prints debugging output to the bottom of the screen.
function debug_print(output)
{
	try
	{	
	var outputdiv = parent.objFrame.document.getElementById("output");
	outputdiv.innerHTML = output;
	}
	catch(e)
	{
		alert('EXCEPTION: debug_print('+output+')\n'+e.description);
	}
}

