//
// ctrl_media_1.js
//

function DeviceAction(netmap, device)
{
  // don't do anything if device is unavailable
  if (device.status == 'unavailable')
    return;

  var search = new Object;
  search['root'] = device.name;
  search['device'] = device.primaryType == 'computer' ? 'desktop' :
      device.primaryType;

  if (device == netmap.devices[0])
  {
    context.navigate("../content_mgr/ctrl_media_2.htm", search);
  }
  else if (device.share.length == 0)
  {
    context.navigate("../content_mgr/ctrl_media_6.htm", search);
  }
  else
  {
     search['path'] = 'file://\\\\' + device.name;
     context.navigate("../content_mgr/ctrl_media_2.htm", search);
  }
}

function DeviceFocus(netmap, focus, device)
{
  // TODO: Improve L10N for these strings (string cat)
  shared.elem.innerHTML = '';
  if (focus)
  {
    if (device == netmap.devices[0])
    {
      shared.elem.innerHTML = context.getString('setup.custom.device.folders.all');
    }
    else if (device.share.length == 0)
    {
      shared.elem.innerHTML = context.getString('setup.custom.device.folders.none');
    }
    else if (device.share.length == 1)
    {
      shared.elem.innerHTML = context.getString('setup.custom.device.folders.single');
    }
    else
    {
      shared.elem.innerHTML = device.share.length + ' ' + 
        context.getString('setup.custom.device.folders.plural');
    }
  }	
}

function DeviceUpdate(netmap, device)
{
  var overlay = device.share.length == 0 ? 'folderOverlay_unshared' :
    'folderOverlay_closed';
  if (device == netmap.devices[0])
      overlay = 'folderOverlay_closed';
  var type = device.primaryType == 'computer' ? 'desktop' :
      device.primaryType;
  if (device.status == 'unavailable')
      type += 'Absent';
  var info = '<div class="'+ type + '"><div class="' + overlay + '"></div></div>';
  info += device.friendly ? TruncateString(device.friendly, 14) : 
      TruncateString(device.name, 14);
  return info;
}

function InitializeDocument()
{
  CreateHead(null);

  var buildType = context.getBuildType();

  // Create the body of the page, including a title  
  body = CreateBody("Sharing", "setTimeout(CollectData, 1)");

  document.write('</body></html>');

  // Create the title of the page.
  CreateTitle(body, context.getString(buildType + '.custom.title'));

  // Create a navigation for buttons, instructions, etc.
  navPane = CreateNavPane(body, true, 'NavPane');
  //  CreateText(navPane, '<h3>', context.getString('setup.custom.device.title'));
  CreateText(navPane, '<p>', context.getString('setup.custom.device.heading'));

  viewPane = CreateViewPane(body, true, 'ViewPane');

  infoPane = CreateInfoPane(body, true, 'InfoPane');
  shared = CreateText(infoPane, 'p', '');

  var navTable = CreateTable(infoPane, null, 2, 1, null, null, true);
  navBtns[0] = CreateButn(navTable.navGrid[0][0], null, context.getString('setup.cancel'), 
                          function() {context.navigate("../content_mgr/home.htm");});
  navBtns[1] = CreateIconButn(navTable.navGrid[1][0], null, context.getString('setup.cs2.btn.help'), 
                          'ButtonHelp', function() {context.navigateHelpBegin("../content_mgr/help_cs2_h1.htm");});

  for(var i = 0; i < navBtns.length; i++)
  {
    WidgetSetNavigation(navBtns[i].navParent, true);
  }
	
  netmap = NetmapCreateWidget(viewPane, 0, DeviceAction, DeviceFocus, DeviceUpdate);
  NetmapDevicesReset(netmap);
}

function CollectData()
{
  try
  {
    // clear the hashtables holding checkbox states. This is in case user hit the 'back' button
    // from traversing through the folders.
    parent.objFrame.monitorState = new Object();
    parent.objFrame.aggregateState = new Object();

    // TODO: replace this netmap code w/ DeviceManager object
    var xmlNetwork = NetmapGetNetwork();
    xmlNetwork.setProperty("SelectionLanguage", "XPath");

    xmlDeviceNodes = xmlNetwork.selectNodes("/network/localhost");
    NetmapDevicesAppend(netmap, xmlDeviceNodes);

    xmlDeviceNodes = xmlNetwork.selectNodes("/network/device");
    NetmapDevicesAppend(netmap, xmlDeviceNodes);
  }
  catch(e)
  {
    // handled by top level handler
  }
 
  WidgetSetFocus(netmap);
}

function TruncateString(str, max)
{
  if (str.length <= max)
    return str;

  return str.substring(0, max) + '...';
}
