//
// ctrl_media_2.js
//

function DeviceAction(netmap, device)
{
  // don't do anything if device is unavailable
  if (device.status == 'unavailable')
    return;

  var search = new Object;
  search['root'] = device.name;
  search['device'] = device.primaryType == 'computer' ? 'desktop' :
      device.primaryType;

  if (device == netmap.devices[0])
  {
    context.navigate("../content_mgr/ctrl_media_3.htm", search);
  }
  else if (device.share.length == 0)
  {
    context.navigate("../content_mgr/ctrl_media_2b.htm", search);
  }
  else
  {
     search['path'] = 'file://\\\\' + device.name;
     context.navigate("../content_mgr/ctrl_media_3.htm", search);
  }
}

function DeviceFocus(netmap, focus, device)
{
  shared.elem.innerHTML = '';
  if (focus)
  {
    var desc;
    if (device == netmap.devices[0])
    {
      desc = context.getString('setup.custom.device.folders.all');
    }
    else if (device.share.length == 0)
    {
      desc  = context.getString('setup.custom.device.folders.none');
    }
    else
    {
      desc = context.getString('setup.custom.device.folders.plural');
    }
    shared.elem.innerHTML = '<p>' + desc + '</p>';
  }	
}

function DeviceUpdate(netmap, device)
{
  var overlay = device.share.length == 0 ? 'folderOverlay_unshared' :
    'folderOverlay_closed';
  if (device == netmap.devices[0])
      overlay = 'folderOverlay_closed';
  var type = device.primaryType == 'computer' ? 'desktop' :
      device.primaryType;
  if (device.status == 'unavailable')
      type += 'Absent';
  var info = '<div class="'+ type + '"><div class="' + overlay + '"></div></div>';
  info = '<div>' + pp2html(device.friendly?device.friendly:device.name, 20, 11) +
		'</div>' + info;
  return info;
}

function InitializeDocument()
{
  CreateHead(null);

  var buildType = context.getBuildType();

  // Create the body of the page, including a title  
  body = CreateBody("Netmap", "LoadTimer()");

  document.write('</body></html>');

  waitIcon = CreateIcon(body, 'waitAnimation');
  WidgetSetVisible(waitIcon, false);

  // Create the title of the page.
  CreateTitle(body, context.getString(buildType + '.title'));
  CreateSubtitle(body, context.getString('setup.cs2.stt'));

  viewPane = CreateViewPane(body, true, 'ViewPane');
  CreateText(viewPane, '<p>', context.getString('setup.custom.device.heading'));

  netmap = NetmapCreateWidget(viewPane, 0, DeviceAction, DeviceFocus, DeviceUpdate);
  NetmapDevicesReset(netmap);

  shared = CreateText(viewPane, '<div>', '');
  shared.elem.className = 'NetmapDescription';

  // Create a navigation for buttons, instructions, etc.
  navPane = CreateNavPane(body, false, 'NavPane');

  navBtns[0] = CreateHelpButn(navPane, null, 
                          function() {context.navigateHelpBegin('../content_mgr/help.htm#IDNL');});
  navBtns[1] = CreateButn(navPane, null, context.getString('setup.cancel'), 
                          function() {context.navigateReferrer();});

  for (var i=0; i< navBtns.length; i++)
    WidgetSetVisible(navBtns[i], false);
}

function LoadTimer()
{
  WidgetSetVisible(waitIcon, true);
  setTimeout(CollectData, 500);
}

function CollectData()
{
  try
  {
    // clear the hashtables holding checkbox states. This is in case user hit the 'back' button
    // from traversing through the folders.
    parent.objFrame.monitorState = new Object();
    parent.objFrame.aggregateState = new Object();

    // TODO: replace this netmap code w/ DeviceManager object
    var xmlNetwork = NetmapGetNetwork();
    xmlNetwork.setProperty("SelectionLanguage", "XPath");

    xmlDeviceNodes = xmlNetwork.selectNodes("/network/localhost");
    NetmapDevicesAppend(netmap, xmlDeviceNodes);

    xmlDeviceNodes = xmlNetwork.selectNodes("/network/device");
    NetmapDevicesAppend(netmap, xmlDeviceNodes);

    // init a hash with existing ips
    var existing = new Object;
    for (var i = 0; i < netmap.devices.length; i++)
    {
      var device = netmap.devices[i];
      for (var j = 0; j < device.adapter.length; j++)
      {
        if (device.adapter[j].ipv4)
        {
          existing[device.adapter[j].ipv4] = device.adapter[j].ipv4;
        }
      }
    } 
    // use existing ips to filter aggregated devices
    xmlDeviceNodes = GetAggregatedServerNodes(existing);
    NetmapDevicesAppend(netmap, xmlDeviceNodes);

    for (var i=0; i< navBtns.length; i++)
      WidgetSetVisible(navBtns[i], true);
  }
  catch(ex)
  {
    context.handleException(ex);
  }
 
  WidgetSetVisible(waitIcon, false);

  WidgetSetFocus(netmap);
}

function TruncateString(str, max)
{
  if (str.length <= max)
    return str;

  return str.substring(0, max) + '...';
}

//------------------------------------------------------------------------------
// str2html - Remove < > & from strings to make appropriate as HTML text.
//------------------------------------------------------------------------------

function str2html(str)
{
	str = str.replace(/&/g, "&amp;");
	str = str.replace(/</g, "&lt;");
	str = str.replace(/>/g, "&gt;");
	return str;
}



//------------------------------------------------------------------------------
// pp2html - Make paragraph appropriate to HTML, including wrap+truncate.
//------------------------------------------------------------------------------

function pp2html(text, length, wrap)
{
	if (text.length > length)
		text = text.substring(0, length-1) + "...";

	if (wrap)
	{
		var temp = text;
		text = "";
		while (temp.length)
		{
			text = text + str2html(temp.substring(0, wrap));
			temp = temp.substring(wrap, temp.length);
			if (temp.length)
				text += "<br>";
		}
	}
	else
		text = str2html(text);

	return text;
}
