//
// ctrl_media_3.js
//

function InitializeDocument()
{	
  CreateHead(null);

  var buildType = context.getBuildType();

  // Create the body of the page, including a title
  body = CreateBody("FolderDive", "LoadTimer()", "Release()");

  document.write('</body></html>');

  waitIcon = CreateIcon(body, 'waitAnimation');
  WidgetSetVisible(waitIcon, false);

  // Create the title of the page.
  CreateTitle(body, context.getString(buildType + '.title'));

  viewPane = CreateViewPane(body, true, 'ViewPane');
  var header = CreateTable(viewPane, null, 1, 2);
  header.navGrid[0][0].elem.innerHTML = '<div class="' + 
      context.request['device'] + '"></div>';
  header.navGrid[0][1].elem.style.paddingLeft = '15px';
 
  var root = context.getString('setup.custom.scanned.from');
  root = root + ' ' + context.request['root'];

  CreateText(header.navGrid[0][1], '<h2>', context.getString('setup.custom.scanned.title'));
  CreateText(header.navGrid[0][1], '<h3>', root);
  CreateText(header.navGrid[0][1], '<p>', 
             context.getString('setup.custom.scanned.heading'));

  var fontSize = parent.document.body.style.zoom > 0 ?
    Math.ceil(26 * parent.document.body.style.zoom) : 26;
  parent.objFrame.Toolbox.SetFont(fontSize, 1, "Helvetica");  

  scroll = CreateScroll(viewPane, null, viewableRows, ScrollUpdate);
  scroll.elem.className = 'Tree';
  scroll.elem.tHead.style.display = 'none';
  scroll.cbKeyStep = Scroll__keyStep;

  footer = CreateViewStats(viewPane, null, true);
  footer.breadcrumb = CreateWidget(viewPane, null, 'skip', 'div').elem;
  footer.breadcrumb.className = "ViewBreadcrumb";

  // Create a navigation for buttons, instructions, etc.
  var fourButton = CreateWidget(body, null, false, 'div');
  fourButton.elem.className = 'FourButton';

  navPane = CreateNavPane(fourButton, false, 'NavPane');

  navBtns[0] = CreateHelpButn(navPane, null, 
                          function() {context.navigateHelpBegin('../content_mgr/help.htm#CS');});
  navBtns[1] = CreateButn(navPane, null, 
                          context.getString('setup.custom.scanned.add-folders'), 
                          function() {context.navigate('../content_mgr/ctrl_media_4.htm', context.request);});
  navBtns[2] = CreateButn(navPane, null, 
                          context.getString('setup.cs3.btn.next'), 
                          function() {Finished();});
  navBtns[3] = CreateButn(navPane, null, 
                          context.getString('setup.cancel'), 
                          function() { context.navigateReferrer(); });

  for (var i=0; i< navBtns.length; i++)
    WidgetSetVisible(navBtns[i], false);

  WidgetSetNavigation(navBtns[2], 'inactive');
}

function Release()
{
  var i;
  for(i = 0; i < displayedItems.length; i++)
  {
    displayedItems[i].dispose();
  }
}

function LoadTimer()
{
  WidgetSetVisible(waitIcon, true);

  setTimeout("CollectData()", 500);
}

function CollectData()
{
  try
  {

    displayedItems = new Array;
    displayTable = new Object;
    var path = context.request['path'];
    var root = context.request['root'];

    var devMan = new DeviceManager(context);

    // ugly fix 'cuz query string switches our \'s to /'s
    if (path)
    {
      path = path.substring(7).replace(/\/\//, "\\\\");
      path = "file://" + path.replace(/\//, "\\");
    }

    InitializeMonitorState(devMan, root);

    // retrieve the currently shared items
    // "special" folders should be displayed first
    if (root && devMan.isLocalDevice(root))
    {
      CollectSpecialFolders(devMan);
    }
    CollectSharedItems(devMan, root);
    CollectAggregatedServers(devMan, root);

    var i = 0;
    while (i < displayedItems.length)
    {
      if (!displayedItems[i].isMarkedForSharing(context) &&
          !displayedItems[i].isChangingShareState(context))
      {
        displayedItems.splice(i, 1);
      }
      else
      {
        i++;
      }
    }

    for (var i = 0; i < displayedItems.length; i++)
    {
      var name = displayedItems[i].name;
      if (name.charAt(name.length - 1) == '\\')
      {
        name = name.substring(0, name.length - 1);
      }

      displayedItems[i].isDrive = (name.length == 2 && name.charAt(1) == ':');
      var volumeName = parent.objFrame.Toolbox.GetVolumeName(displayedItems[i].name);
      if (volumeName)
      {
        displayedItems[i].volumeName = volumeName; 
        name = volumeName + '(' + name + ')';
      }
      displayedItems[i].html = TruncateName(name , 50); 
    }

    // set button visibility and input focus
    //
    for (var i=0; i< navBtns.length; i++)
      WidgetSetVisible(navBtns[i], true);
    
    if (displayedItems.length > 0)
    {
      // we have items, configure scroll viewport
      ScrollSetViewport(scroll, 0, displayedItems.length, false);
      WidgetSetFocus(scroll);
    }
    else
    {
      // no folders are setup, display placeholder text
      ScrollSetViewport(scroll, 0, 1, false);
      ScrollSetRow(scroll, 0, 
                   context.getString('setup.custom.scanned.no-folders'));
      WidgetSetNavigation(scroll, 'skip');
      WidgetSetFocus(body);
    }
  }
  catch(ex)
  {
    context.handleException(ex);
  }

  WidgetSetNavigation(navBtns[2], SelectionHasChanged() ? 'leaf' : 'inactive' );
  WidgetSetVisible(waitIcon, false);
}

function InitializeMonitorState(devMan, root)
{
  var itr = context.objFrame.synchronizer.monitors;
  if (itr == null)
    mxThrow(context.objFrame.synchronizer);
  var monitors = VBArray(itr.next(10000)).toArray();
  mxThrowIfFailed(itr);

  for (var i = 0; i < monitors.length; i++)
  {
    var fileObj = monitors[i].fileSystemObject; 
    // file system object may be null if no longer accessible
    if (fileObj)
    {
      var url = fileObj.url;
      if (context.objFrame.monitorState[url] == null &&
          devMan.isDeviceUrl(root, url))
      {          
        var state = new Object;
        state['pre'] = true;
        state['post'] = true;
        context.objFrame.monitorState[url] = state;       
      }
    }
  }
}

function CollectSpecialFolders(devMan)
{
  var folders = new Array;
  devMan.getSpecialFolders(folders);
  
  for (var i = 0; i < folders.length; i++)
  {
    if (displayTable[folders[i].id] == null)
    {
      displayTable[folders[i].id] = folders[i];
      displayedItems.push(folders[i]);  
    }
  }
}

function CollectSharedItems(devMan, root)
{
  for (var key in context.objFrame.monitorState)
  {
    var val = context.objFrame.monitorState[key];
    if (val != null && 
        (val['post'] == true || val['pre'] == true))
    {
      var fileObj = parent.objFrame.fileServices.byURL(key);
      if (fileObj == null)
        continue;

      if (displayTable[fileObj.url] == null)
      {
        var item = new FileSystemItem();
        item.init(fileObj);
        item.selected = val;
        displayTable[fileObj.url] = item;
        displayedItems.push(item);
      }
    }
  }
}

function CollectAggregatedServers(devMan, root)
{
  var servers = new Array;
  devMan.getAggregatedServers(root, servers);
  
  for (var i = 0; i < servers.length; i++)
  {
    var state = new Object;
    if (context.objFrame.aggregator.isAggregated(servers[i].data))
    {
      state['pre'] = true;
      state['post'] = true;
    }
    else
    {
      state['pre'] = false;
      state['post'] = false;
    }
    context.objFrame.aggregateState[servers[i].id] = state;
    displayedItems.push(servers[i]);
  }
}

function SelectionHasChanged()
{
  for (var i = 0 ; i < displayedItems.length; i++)
  {
    if (displayedItems[i].isChangingShareState(context))
      return true;
  }
  return false;
}

function CheckboxAction(row, item)
{
  item.markForSharing(context, 
                      !item.isMarkedForSharing(context));
  ScrollRow(scroll, item, item.scrollRow);
  WidgetSetNavigation(navBtns[2], SelectionHasChanged() ? 'leaf' : 'inactive' );
}

function ScrollRowFocus(row, focus, item)
{
  if (focus)
  {
    var rect = row.elem.getBoundingClientRect();
    crumb = item.isFolder ? 
        TruncatePath(ConvertMXURLtoPath(item.id), rect.right - rect.left - 200) : '';

    SetScrollLabel(item.scrollRow + scroll.viewFirst + 1, displayedItems.length);
  }
}

function ScrollRow(scroll, item, row)
{
  var selected = item.isMarkedForSharing(context);
  var cbox = selected ? 'class="TreeCheckOnSelect"' : 
       'class="TreeCheckOffSelect"';

  var inner = '<span ' + cbox + '></span>';

  var content = item.html;
 
  var iconClass = item.isDrive ? 'driveIcon' : 
    (item.isFolder ? 'folderIconClosed' : 'cdsIcon');
  inner += '<span class="' + iconClass + '" style="margin-left:10px"></span>' + 
      '<span style="padding-left:10px;vertical-align:middle">' + content + '</span>';

  scroll.navGrid[row][0].cbFocus = ScrollRowFocus;
  ScrollSetRow(scroll, row, inner, CheckboxAction, null, item);  

  item.scrollRow = row;
}

function ScrollUpdate(scroll, start, count)
{
  // no items to display
  if (!displayedItems.length)
    return;

  var viewFirst = scroll.viewFirst + start;
  for (var i = start; i < start + count; i++)
  {
    ScrollRow(scroll, displayedItems[viewFirst + i], i);
  } 

  // ensure breadcrumb is updated  
  WidgetSetFocus(widgetNavFocus);
}

function SetScrollLabel(item, count)
{
  var labelText = context.getString('setup.connector.of'); 
  label = item + ' ' + labelText + ' ' + count;
  footer.label.innerHTML = label;
  footer.breadcrumb.innerHTML = crumb;
}

function Scroll__keyStep(scroll, step, vert)
{
  if (vert && step > 0)
  {
    // allow vertical navigation to leave the end of the tree
    if (scroll.viewFirst + scroll.navRows*scroll.navCols >= scroll.viewTotal)
      return false;
  }
  if (GridKeyStep(scroll, step, vert)) // default nav
  {
    if (widgetNavFocus && widgetNavFocus.navSkip){
        Scroll__keyStep(scroll, step, vert);
    }
    return true;
  }
  return false;
}
