//
// ctrl_media_4.js
//

function InitializeDocument()
{
  CreateHead(null);

  var buildType = context.getBuildType();

  // Create the body of the page, including a title
  body = CreateBody("FolderDive", "LoadTimer()", "Release()");

  document.write('</body></html>');

  waitIcon = CreateIcon(body, 'waitAnimation');
  WidgetSetVisible(waitIcon, false);

  // Create the title of the page.
  CreateTitle(body, context.getString(buildType + '.title'));

  viewPane = CreateViewPane(body, true, 'ViewPane');
  var header = CreateTable(viewPane, null, 1, 2);

  header.navGrid[0][0].elem.innerHTML = '<div class="' + 
      context.request['device'] + '"></div>';
  header.navGrid[0][1].elem.style.paddingLeft = '15px';

  var headerText = context.getString('setup.custom.available-folders');

  var root = context.getString('setup.custom.scanned.from');
  root = root + ' ' + context.request['root'];

  CreateText(header.navGrid[0][1], '<h2>', headerText);
  CreateText(header.navGrid[0][1], '<h3>', root);
  CreateText(header.navGrid[0][1], '<p>', 
             context.getString('setup.custom.available.text'));

  var fontSize = parent.document.body.style.zoom > 0 ?
    Math.ceil(26 * parent.document.body.style.zoom) : 26;
  parent.objFrame.Toolbox.SetFont(fontSize, 1, "Helvetica");  

  tree = CreateTreeControl(viewPane, null, viewableRows);
  CreateTreeStats(tree, viewPane);

  // Create a navigation for buttons, instructions, etc.
  navPane = CreateNavPane(body, false, 'NavPane');

  navBtns[0] = CreateHelpButn(navPane, null, 
                          function() {context.navigateHelpBegin('../content_mgr/help.htm#AF');});
  navBtns[1] = CreateButn(navPane, null, 
                          context.getString('setup.cs4.btn.next'), 
                          function() {Finished();});
  navBtns[2] = CreateButn(navPane, null, 
                          context.getString('setup.cancel'), 
                          function() {context.navigateReferrer();});

  for (var i=0; i< navBtns.length; i++)
    WidgetSetVisible(navBtns[i], false);

  WidgetSetNavigation(navBtns[1], SelectionHasChanged() ? 'leaf' : 'inactive' );
}

function Release()
{
  var i;
  for(i = 0; i < displayedItems.length; i++)
  {
    displayedItems[i].dispose();
  }
}

function LoadTimer()
{
  WidgetSetVisible(waitIcon, true);

  setTimeout("CollectData()", 500);
}

function CollectData()
{
  try
  {
    displayedItems = new Array;
    var path = context.request['path'];
    var root = context.request['root'];

    var devMan = new DeviceManager(context);
    var isRootDev = root && devMan.isLocalDevice(root);

    // ugly fix 'cuz query string switches our \'s to /'s
    if (path)
    {
      path = path.substring(7).replace(/\/\//, "\\\\");
      path = "file://" + path.replace(/\//, "\\");
    }

    // if we're at the local root, include "My Documents"
    if (isRootDev)
    {
      var fileObj = context.objFrame.fileServices.byURL(
                      context.objFrame.Toolbox.UserDocumentPath(""));
      if (fileObj)
      {
        var item = new FileSystemItem();
        item.init(fileObj);
        displayedItems.push(item);
        fileObj = null;
      }
    } 

    // retrieve folders for this path
    devMan.getFolders(path, displayedItems);
    devMan.getAggregatedServers(root, displayedItems);

    // filter out mapped drives...these shares will be displayed in host's context
    if (isRootDev)
    {
      var i = 0;
      while (i < displayedItems.length)
      {
        var unc = parent.objFrame.Toolbox.PathToUNC(displayedItems[i].id);
        if (unc)
        {
          displayedItems.splice(i, 1);
        }
        else
        {
          i++;
        }
      }
    }

    // collect any required info for display
    for (var i=0; i < displayedItems.length; i++)
    { 
      var volumeName = parent.objFrame.Toolbox.GetVolumeName(displayedItems[i].name);
      var name = displayedItems[i].name;
      if (name.charAt(name.length - 1) == '\\')
      {
        name = name.substring(0, name.length - 1);
      }
      displayedItems[i].isDrive = (name.length == 2 && name.charAt(1) == ':');
      displayedItems[i].volumeName = volumeName;
      displayedItems[i].html = volumeName ? 
          volumeName + ' (' + name + ')' : name;
      displayedItems[i].cbAction = displayedItems[i].isFolder && 
          IsExcludedPath(ConvertMXURLtoPath(displayedItems[i].id)) ? null : CheckboxAction;
      displayedItems[i].cbChildren = displayedItems[i].isFolder ? 
          GetNodeChildren : null;
      displayedItems[i].cbFocus = NodeFocus;
      displayedItems[i].cbUpdate = NodeUpdate;
    } 
  }
  catch(ex)
  {
    context.handleException(ex);
  }

  var roots = new Array;
  for(var i = 0; i < displayedItems.length; i++)
  {
    var uid = displayedItems[i].id;
    var root = CreateTreeNode(tree, null, 
                              displayedItems[i].html,
                              displayedItems[i].cbAction,
                              displayedItems[i].cbChildren,
                              displayedItems[i].cbFocus,
                              displayedItems[i].cbUpdate,
                              displayedItems[i]);

    root.selected = displayedItems[i].isMarkedForSharing(context);
    roots.push(root);
  }
  
  TreeInsertRoots(tree, roots);
  TreeSetViewport(tree, 0, roots.length, false);

  for (var i=0; i< navBtns.length; i++)
    WidgetSetVisible(navBtns[i], true);

  WidgetSetVisible(waitIcon, false);

  if (!roots.length)
  {
    WidgetSetNavigation(navBtns[1], 'inactive' );
    WidgetSetFocus(navBtns[2]);
  }
  else
  {
    WidgetSetFocus(tree);
  }
}

function GetNodeChildren(tree, node, children, nodeData)
{
  // don't drill down more than 10 deep!
  if (node.depth > 9)
  {
    return;
  }

  try
  {
    displayedItems = new Array;
    nodeData.getFolders(displayedItems);

    // collect any required info for display
    for (var i=0; i < displayedItems.length; i++)
    {
      var name = displayedItems[i].name;
      if (name.length > 3 &&
          name.charAt(name.length - 1) == '\\')
      {
        name = name.substring(0, name.length - 1);
      }
      displayedItems[i].html = name;
      displayedItems[i].cbAction = displayedItems[i].isFolder && 
          IsExcludedPath(ConvertMXURLtoPath(displayedItems[i].id)) ? null : CheckboxAction;
      displayedItems[i].cbChildren = displayedItems[i].isFolder ? 
          GetNodeChildren : null;
      displayedItems[i].cbFocus = NodeFocus;
      displayedItems[i].cbUpdate = NodeUpdate;
    } 
  }
  catch(e)
  {
    context.handleException(ex);
  }

  for (var i = 0; i < displayedItems.length; i++)
  {
    var uid = displayedItems[i].id;
    var child = CreateTreeNode(tree, node, 
                              displayedItems[i].html,
                              displayedItems[i].cbAction,
                              displayedItems[i].cbChildren,
                              displayedItems[i].cbFocus,
                              displayedItems[i].cbUpdate,
                              displayedItems[i]);

    child.selected = displayedItems[i].isMarkedForSharing(context);
    children.push(child);
  }
}

function CheckboxAction(cell, node, nodeData, selected)
{
  // don't mark items as removed because a parent was selected
  // synchronizer will do the right thing w/ this
  if (!selected && node.selected == 'parent')
  {
    return;
  }
  nodeData.markForSharing(context, selected);

  var bSel = SelectionHasChanged();
  WidgetSetNavigation(navBtns[1], bSel ? 'leaf' : 'inactive' );

  if (bSel){
    navPane.navCurr = navBtns[1];
  }
}

var currZoom = 0;

function NodeFocus(tree, node, nodeData, focus)
{
  if (parent.document.body.style.zoom != currZoom)
  {
    currZoom = parent.document.body.style.zoom;
    var fontSize = currZoom > 0 ?
      Math.ceil(26 * currZoom) : 26;
    parent.objFrame.Toolbox.SetFont(fontSize, 1, "Helvetica");  
  }

  var rect = tree.elem.getBoundingClientRect();
  var msg = nodeData.isFolder ? 
    TruncatePath(ConvertMXURLtoPath(nodeData.id), rect.right - rect.left - 200) : '';
  TreeSetStatsMessage(tree, msg);
} 

function NodeUpdate(tree, node, content, width)
{
  var zoom = parent.document.body.style.zoom > 0 ? 
    parent.document.body.style.zoom : 1;
  width -= node.depth * 36 * zoom + 180 * zoom;
  TreeSetNodeHtml(tree, node,
                  context.objFrame.Toolbox.Truncate(content, width));
  var icon = 'folderIconClosed';
  if (node.data.isDrive)
  {
    icon = 'driveIcon';
  }
  else if (node.data.isServer)
  {
    icon = 'cdsIcon';
  }
  else if (node.data.isFolder && node.expanded)
  {
    icon = 'folderIconOpen';
  }
  TreeSetNodeIcon(tree, node, icon);
}

function SelectionHasChanged()
{
  for (var key in parent.objFrame.monitorState)
  {
    var val = parent.objFrame.monitorState[key];
    if (val && val['pre'] != val['post'])
    {
      return true;
    }
  }
  for (var key in parent.objFrame.aggregateState)
  {
    var val = parent.objFrame.aggregateState[key];
    if (val && val['pre'] != val['post'])
    {
      return true;
    }
  }
  return false;
}
