
/////////////////////////////////////////////////////////////////
// bitwise flag that defines the file type. see MXDirectory.cpp of
// the M1 ActiveX SDK.
var M1_DIR_ATTR_FOLDER	= 0x002;
var M1_DIR_ATTR_HIDDEN  = 0x020;
var M1_DIR_ATTR_NETWORK	= 0x100;
var M1_DIR_ATTR_OPTICAL = 0x200;
var M1_DIR_ATTR_REMOVABLE = 0x400;


/////////////////////////////////////////////////////////////////
// bitwise flag that defines the flag for retrieving file count.
// see MXServer.cpp of the M1 ActiveX SDK.

var MCOUNT_FLAGS_CONTEXT_AGG  = 0x010000;
var MCOUNT_FLAGS_CONTEXT_SYNC = 0x020000;
var MCOUNT_FLAGS_TYPE_MUSIC   = 0x000001;
var MCOUNT_FLAGS_TYPE_IMAGE   = 0x000002;
var MCOUNT_FLAGS_TYPE_VIDEO   = 0x000004;


var excludeContent = new Array
(
	"%SystemDrive%",
	"%ProgramFiles%",
	"%SystemRoot%"
)

/////////////////////////////////////////////////////////////////
// Prints debugging output to the bottom of the screen.
function debug_print(output)
{
  try
  {	
    var outputdiv = parent.objFrame.document.getElementById("output");
    outputdiv.innerHTML = output;
  }
  catch(e)
  {
    alert('EXCEPTION: debug_print('+output+')\n'+e.description);
  }
}

/////////////////////////////////////////////////////////////////
// Formats the url to normalized URL format.
function ConvertWebURLtoMXURL(src)
{
	try
	{	
        var dest = unescape(src);
	dest = dest.replace(/\//gi, "\\");
	dest = dest.replace(/\?/gi, "");
	dest = dest.replace(/file:\\\\/gi, "file://");
	return dest;
	}
	catch(e)
	{
		alert('EXCEPTION: ConvertWebURLtoMXURL('+src+')\n'+e.description);
	}
}

/////////////////////////////////////////////////////////////////
// Formats the url to normalized URL format.
function ConvertMXURLtoPath(src)
{
	try
	{	
	var dest = src;
	if (src.charAt(src.length-1) == '\\' || src.charAt(src.length-1) == '/')
		dest = src.substr(0, src.length-1);
	dest = dest.replace(/file:\/\//gi, "");
	return dest;
	}
	catch(e)
	{
		alert('EXCEPTION: ConvertMXURLtoPath('+src+')\n'+e.description);
	}
}

function MatchIPinUrl(url)
{
  var rexp = /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/;
  var res = url.match(rexp);
  if (res)
  {
    return res[0];
  }
  return null;
}

function CreateBody(className, onLoad, onUnload)
{
  var b = '<body id="body" bgcolor="#134D97" onselectstart="return false"';
  if (className)
  {
    b += ' class="' + className + '"';
  }
  if (onLoad)
  {
    b += ' onload="' + onLoad + '"';
  }
  if (onUnload)
  {
    b+= ' onunload="' + onUnload + '"';
  }
  b += '>';
  document.write(b);

  var body = CreateWidget(null, 'body', true);
  var brand = CreateBrand(body);

  return body;
}

function CreateHelpBody()
{
  return CreateBody("Wide");
}

function CreateBreak(navParent)
{
  return CreateWidget(navParent, null, 'skip', 'br');
}

function CreateTitle(parent, title)
{
  // Titles have been removed.
  // This method overrides the one implemented in scripts/style.js
}

/////////////////////////////////////////////////////////////////
// Get the file name from a path.
function GetPathName(src)
{
	try
	{	
	var name = src.split("\\");
	if (name[name.length-1].length > 0)
		return name[name.length-1];
	else
		return name[name.length-2];
	}
	catch(e)
	{
		alert('EXCEPTION: GetPathName('+src+')\n'+e.description);
	}
}

/////////////////////////////////////////////////////////////////
// Get the list of relevant local paths.
function GetSpecialPaths()
{

	// Return same paths as used by standard setup as per NMPR PRD.
	return GetStandardSetupPaths();

}


function IsSpecialRoot(path)
{
  path = path.substring(7, path.length - 1);
  var user = parent.objFrame.Toolbox.UserDocumentPath("");
  if (user == path)
    return true;

  return false;
}

function GetStandardSetupPaths()
{
  try
  {	
    var paths = new Array;

    // find whether these Windows folders exist in the local computer.
    var path = new Object;
    path.location = parent.objFrame.Toolbox.UserDocumentPath("");
    if (path) {
      path.label = "";
      paths.push(path);
    }
    // added Shared Documents as per NMPR PRD.
    // LTD: change to SharedDocumentPath() from API once available.
    var path = new Object;
    path.location = parent.objFrame.Toolbox.ExpandEnvironmentStrings("%ALLUSERSPROFILE%\\Documents");
    if (path) {
    // LTD: localize "Shared Documents" label
      path.label = "Shared Documents";
      paths.push(path);
    }

    return paths;
  }
  catch(e)
  {
	// Changed to reflect actual function we are in.
    alert('EXCEPTION: GetStandardSetupPaths()\n'+e.description);
  }
}



/////////////////////////////////////////////////////////////////
// Determine whether any of the excluded directory is shared.
function IsExcludedPath(path)
{
  var i;

  for(i = 0; i < excludeContent.length; i++)
  {
    var plow = path.toLowerCase();
    // normalize
    if (plow.charAt(plow.length - 1) == '\\')
      plow = plow.substring(0, plow.length - 1);
    var estr = parent.objFrame.Toolbox.
      ExpandEnvironmentStrings(excludeContent[i]);
    if (estr != null)
    {
      if (estr.toLowerCase() == plow)
        return true;
    }
  }
  return false;
}

function GetAggregatedServers(filterIPs, servers)
{
  // get the list of servers from aggregator for comparison later.
  var aggItr = parent.objFrame.aggregator.servers;
  mxThrowIfFailed(parent.objFrame.aggregator);

  var aggSvrs = VBArray(aggItr.next(1000)).toArray();
  mxThrowIfFailed(aggItr);

  aggItr.dispose();
  aggItr = null;

  // get the list of media servers, find each by ip address.
  var serverItr = parent.objFrame.MXMediaOne.servers;
  mxThrowIfFailed(parent.objFrame.MXMediaOne);

  all = VBArray(serverItr.next(1000000)).toArray();
  mxThrowIfFailed(serverItr);

  serverItr.dispose();
  serverItr = null;

  for (var i=0; i< all.length; i++)
  {
    // make sure it's in the aggregator too.
    var j;
    for (j = 0; j < aggSvrs.length; j++)
    {
      if (aggSvrs[j].identifier == all[i].identifier)
      {
	  break;
      }
    }
    if (j == aggSvrs.length)
    {
      // server not found in the aggregator's list.
      all[i].dispose();
    }
    else
    {
      // if we're filtering by device, check the ips
      if (filterIPs)
      {
        var ips = VBArray(all[i].protocolURLs).toArray();
        if (!MatchIPs(filterIPs, ips))
        {
          continue;
        }
      }
      var item = new ServerItem();
      item.init(all[i]);
      servers.push(item);
      }
    }

    // dispose of the agg servers
    for (i = 0; i < aggSvrs.length; i++)
    {
      aggSvrs[i].dispose();
      aggSvrs[i] = null;
    }
}

function GetAggregatedServerNodes(existing)
{
  var servers = new Array;
  GetAggregatedServers(null, servers);

  var serverXml = '<network>';
  
  for (var i = 0; i < servers.length; i++)
  {
    var exists = false;
    var server = servers[i].data;
    var deviceXml = '<device status="connected">' +
      '<uid>' + server.identifier + '</uid>' +
      '<name>' + server.name + '</name>' +
      '<friendly>' + server.name + '</friendly>' +
      '<type class="computer"></type>' +
      '<aggregated>true</aggregated>';

    var urls = VBArray(server.protocolURLs).toArray();
    for (var j = 0; j < urls.length; j++)
    {
      var ip = MatchIPinUrl(urls[j]);
      if (ip)
      {
        // if the ip for this device is known, skip it
        if (existing[ip] != null)
        {
          exists = true;
          break;
        }
        
        deviceXml += '<adapter><ipv4>' + ip + '</ipv4></adapter>';
        existing[ip] = ip;
      }
    }
    deviceXml += '<share>' + server.name + '</share>';
    deviceXml += '</device>';

    if (!exists)
    {
      serverXml += deviceXml;
    }
  }
  serverXml += '</network>';
    
  xmlNetwork = new ActiveXObject("Msxml2.DOMDocument");
  xmlNetwork.async = false;
  xmlNetwork.resolveExternals= false; 
  xmlNetwork.validateOnParse = true; 
  xmlNetwork.loadXML(serverXml);

  return xmlNetwork.selectNodes("/network/device");
}

function MatchIPs(ipList1, ipList2)
{
  for (var i = 0; i < ipList1.length; i++)
    {
    var ip1 = MatchIPinUrl(ipList1[i]);
    for (var j = 0; j < ipList2.length; j++)
    {
      var ip2 = MatchIPinUrl(ipList2[j]);
      if (ip1 == ip2)
      {
        return true;
      }
    }
  }
  return false;
}

/////////////////////////////////////////////////////////////////
// Get the list of network devices.
function GetNetmap(path)
{
	try
	{	
	var xmlDeviceNodes = xmlNetwork.selectNodes(path);
	for (var i=0; i<xmlDeviceNodes.length; i++)
	{
		var device = new Object();
		device.name = (xmlDeviceNodes.item(i).getElementsByTagName('name')).item(0).text;

		// find device in computer.
		var fileObj = parent.objFrame.fileServices.byURL("\\\\"+device.name);
		if (fileObj)
			deviceObjs.push(fileObj);
		else
			continue;

		var friendly = (xmlDeviceNodes.item(i).getElementsByTagName('friendly')).item(0);
		if (friendly)
			device.friendly = friendly.text;
		else
			device.friendly = device.name;
		netmap.push(device);
	}
	}
	catch(e)
	{
		alert('EXCEPTION: GetNetmap('+path+')\n'+e.description);
	}
}

/////////////////////////////////////////////////////////////////
// navigational buttons for Sharing Controls content pages.
function Finished()
{	
  parent.objFrame.confirming = true;
  context.navigate("../content_mgr/ctrl_media_5.htm", context.request);
}

function NormalizePath(path)
{
  path = path.replace(/\\/g, '/');
  if (path.charAt(path.length - 1) != '/')
    path += '/';
  return path;
}

function ProgressTable(pageContext, total, music, pictures, videos)
{
  var tableText = '<table style="color: rgb(253,253,165);font-size: 18pt;">';
  if (total != null)
  {
    tableText += '<tr><td style="text-align:left">';
    tableText += pageContext.getString('setup.progress.scanned');
    tableText += '</td><td style="text-align:left">' + total + '</td></tr>';
  }

  tableText += '<tr><td style="text-align:left">'
  tableText += pageContext.getString('setup.progress.added');
  tableText += '</td><td style="text-align:left">' + music + ' ' + 
    (music == 1 ? pageContext.getString('setup.progress.song.single') :
      pageContext.getString('setup.progress.song.plural')) + '</td></tr>';
  tableText += '<tr><td></td><td style="text-align:left">' + pictures + ' ' + 
   (pictures == 1 ? pageContext.getString('setup.progress.picture.single') :
      pageContext.getString('setup.progress.picture.plural')) + '</td></tr>';
  tableText += '<tr><td></td><td style="text-align:left">' + videos + ' ' + 
    (videos == 1 ? pageContext.getString('setup.progress.video.single') :
      pageContext.getString('setup.progress.video.plural')) + '</td></tr>';
  tableText += '</table>';
  return tableText;
}

function FramesetPageLoad(href, replace)
{

	var newLoc = PageURL(href), currLoc = '';
	var currLoc = PageURL(unescape(location.href));


	if ((!newLoc.path.length) || (newLoc.path[0].indexOf(':') < 0))
	{ 

	
		// Remove the HTML file from the path; FOO
		// LTD: Situation where current location isn't a file it's a path (obscure)
		if (!newLoc.href)
			newLoc.path[0] = currLoc.path[currLoc.path.length-1];		
		currLoc.path.length = currLoc.path.length - 1;


		// Walk through the relative path and resolve using the absolute path
		for (var i = 0; i < newLoc.path.length; i++)
		{
			// Check for relative parent references
			if (newLoc.path[i] == '..')
			{
				if (currLoc.path.length && currLoc.path[currLoc.path.length-1])
					currLoc.path.length = currLoc.path.length-1;
			}
			
			// Otherwise append any path or file to the absolute path 
			else if (newLoc.path[i] != '.')
				currLoc.path[currLoc.path.length] = newLoc.path[i];
		}


		// Join the path back together, and append hash and search parts
		newLoc.href = currLoc.path.join('/');
		href = newLoc.href + newLoc.hash + newLoc.search;
	}
	

	// Either load or replace the new page	
	var bounce = parent.urlFrame.bounce ? 1 : 0;
	if (replace)
		parent.urlFrame.location.replace('../content_mgr/urlFrame'+bounce+'.htm?'+escape(href));
	else
		parent.urlFrame.location = '../content_mgr/urlFrame'+(bounce?0:1)+'.htm?'+escape(href);

}

function ParentIsSelected(url)
{
  var lower = url.toLowerCase();
  for (var key in parent.objFrame.monitorState)
  {
    var val = parent.objFrame.monitorState[key];
    if (val && val['post'] == true)
    {
      var keyLower = key.toLowerCase();
      if (lower.length != keyLower.length &&
          lower.indexOf(keyLower) == 0)
      {
        return true;
      }
    }
  }
  return false; 
}

function TruncatePath(path, max)
{
  return parent.objFrame.Toolbox.TruncatePath(path, max);
}

function TruncateName(name, max)
{
  if (name.length <= max)
    return name;

  return name.substring(0, max - 3) + '...';
}

/** Exception objects **/
function MXException(errorSource)
{
  this.errorCode = errorSource.error.result;
  this.errorSource = errorSource;
  this.errorString = errorSource.error.action;
}

function mxThrow(obj)
{
  throw new MXException(obj);
}

function mxThrowIfFailed(obj)
{
  if (obj.error.result != MERROR_OK)
    throw new MXException(obj);
}

/** PageContext object **/
function PageContext(parent, window)
{
  this.objFrame = parent.objFrame;
  this.parent = parent;
  this.window = window;
  this.l10nDoc = L10NLoadStrings(
                  'language/'+ globalLang + '/content_mgr.xml');
  // parse query string
  this.request = new Object();
  var pairs = window.location.search.substring(1).split("&");  // remove the "?"
  for(var i = 0; i < pairs.length; i++)
  {
    var pair = pairs[i].split("=");
    var val =  (pair.length > 1) ? unescape(pair[1]) : "";

    if (this.request[pair[0]])
    {
      var vals;
      if (typeof(this.request[pair[0]]) == 'object')
      {
        vals = this.request[pair[0]];
      }
      else
      {
        vals = new Array;
        vals.push(this.request[pair[0]]);
        this.request[pair[0]] = vals;
      }
      vals.push(val);
    }
    else
    {
      this.request[pair[0]] = val;
    }
  }
  // Initialize class methods
  this.getBuildAction = PageContext__getBuildAction;
  this.getBuildType = PageContext__getBuildType;
  this.getMediaType = PageContext__getMediaType;
  this.getString = PageContext__getString;
  this.handleException = PageContext__handleException;
  this.navigate = PageContext__navigate;
  this.navigateHelpBegin = PageContext__navigateHelpBegin;
  this.navigateHelpNext = PageContext__navigateHelpNext;
  this.navigateHelpReferrer = PageContext__navigateHelpReferrer;
  this.navigateHome = PageContext__navigateHome;
  this.navigateReferrer = PageContext__navigateReferrer;
  this.reportError = PageContext__reportError;
}

function PageContext__getBuildAction()
{
  return "build";
}

function PageContext__getBuildType()
{
  return this.request['type'] ? this.request['type'] : "setup";
}

function PageContext__getMediaType()
{
  return "media";
}

function PageContext__getString(stringId)
{
  return L10NString(this.l10nDoc, stringId);
}

function PageContext__handleException(ex)
{
  if (ex instanceof MXException)
  {
    if (this.objFrame.connectionManager.getStatus() == 'stopped')
    {
      this.navigate('../content_mgr/server_stopped_1.htm', null, true);
    }
    else
    {
      this.navigate("../content_mgr/server_stopped_3.htm", null, true);
    }
  }
  else
  {
    this.reportError(ex.number, ex.name + '--' + ex.message);
  }
}

function PageContext__navigate(page, search, replace)
{
  var params = search == null ? new Object : search;

  if (replace)
  {
    params['helpref'] = this.request['helpref'];
    params['home'] = this.request['home'];
  }
  else
  {
    params['helpref'] = this.request['helpref'] == null ? 1 :
      ++this.request['helpref'];
    params['home'] = this.request['home'] == null ? 1 : 
      ++this.request['home'];
  }

  params['ref'] = this.request['ref'];
  params['type'] = this.request['type'];

  var query = '?';
  for(var key in params)
  {
    var val = params[key];
    if (val != null)
    {
      if (typeof(val) == 'object')
      {
        for (var i = 0; i < val.length;i++)
        {
          query += key + '=' + escape(val[i]) + '&';
        }
      }
      else
      {
        query += key + '=' + escape(val) + '&';
      }
    }
  }

  FramesetPageLoad(page + query, replace);
}

function PageContext__navigateHelpBegin(page, search)
{
  this.request['helpref'] = null;
  this.navigate(page, search);
}

function PageContext__navigateHelpNext(page, search)
{
  // just a simple navigate
  this.navigate(page, search);
}

function PageContext__navigateHelpReferrer()
{
  this.window.history.go(-this.request['helpref']);

}

function PageContext__navigateHome()
{
  this.window.history.go(-this.request['home']);
}

function PageContext__navigateReferrer()
{
  var ref = this.request['ref'];
  if (ref == null)
  {
    this.navigateHome();
  }
  else
  {
    this.window.top.location = ref;
  }
}

function PageContext__reportError(errorCode, errorMessage)
{
  alert('Exception: ' + errorMessage + '[' + errorCode + ']');
}

/** BuildManager object **/
function BuildManager(pageContext, onProgress, onComplete)
{
  this.pageContext = pageContext;
  this.onProgress = onProgress;
  this.onComplete = onComplete;

  this.aggregating = false;
  this.synchronizing = false;

  // Initialize class methods
  this.build = BuildManager__build;
  this.progress = BuildManager__progress;
  this.stop = BuildManager__stop;
}

function BuildManager__build(filesToSync, filesToUnsync, 
                             serversToAgg, serversToUnagg)
{
  var s = this.pageContext.objFrame.synchronizer;
  var a = this.pageContext.objFrame.aggregator;

  this.pageContext.objFrame.localServer.resetCount(-1);
  mxThrowIfFailed(this.pageContext.objFrame.localServer);
  
  this.complete = new Array;
  this.pending = new Array;
  this.totalScanned = 0;
  this.totalMusic = 0;
  this.totalPictures = 0;
  this.totalVideos = 0;

  try
  {
    if (!(filesToSync == null && filesToUnsync == null))
    {
      s.notifyChanges();
      mxThrowIfFailed(s);
      this.synchronizing = true;
    }
  
    if (!(serversToAgg == null && serversToUnagg == null))
    {
      a.notifyChanges();
      mxThrowIfFailed(a);
      this.aggregating = true;
    }

    this.agg = a;
    this.sync = s;
    this.filesToSync = filesToSync;
    this.filesToUnsync = filesToUnsync;
    this.serversToAgg = serversToAgg;
    this.serversToUnagg = serversToUnagg;

    var i;
    if (filesToUnsync != null && filesToUnsync.length)
    {
      var permMask = M1_DIR_ATTR_NETWORK | M1_DIR_ATTR_OPTICAL |
        M1_DIR_ATTR_REMOVABLE;

      var pendingRevokes = new Array;

      for (i=0; i < filesToUnsync.length; i++)
      {
        pendingRevokes.push(i);
      }

      // prevent completion until we have tried to sync everything!
      buildMan.pending[0] = 'revoke';

      for (i=0; i < filesToUnsync.length; i++)
      {
        var buildStatus = new Object;
        buildStatus.buildMan = this;
        buildStatus.pendingRevokes = pendingRevokes;

        var mon = filesToUnsync[i].data.monitor;
        mxThrowIfFailed(filesToUnsync[i].data);

        if (mon)
        {
          buildStatus.mon = mon;

          // can't change permissions on these mount types
          if ((filesToUnsync[i].data.attributes & permMask) == 0)
          {
            // We'll only attempt to unshare if we can revoke read access.
            var path = ConvertMXURLtoPath(filesToUnsync[i].data.url);
            parent.objFrame.Toolbox.RevokeReadAsync(path, 
                                                   BuildManager__revokeComplete, 
                                                   buildStatus);
          }
          else
          {
            var comp = function(){
              BuildManager__revokeComplete(0, true, buildStatus);
            }
            setTimeout(comp, 1);
          }
        }
        else{
          BuildManager__revokeComplete(0, false, buildStatus);
        }
      }
    }
    else{
      BuildManager__doGrant(buildMan);
    }
  }
  catch(ex)
  {
    this.stop();
    throw ex;
  }
}

function BuildManager__revokeComplete(errorCode, result, buildStatus)
{
  var mon = buildStatus.mon;
  var buildMan = buildStatus.buildMan;
  var s = buildMan.sync;

  if (errorCode == 0 && result == true)
  {
    s.unshare(mon);
  }

  buildStatus.pendingRevokes.pop();
  if (buildStatus.pendingRevokes.length == 0){
    buildMan.pending.splice(0, 1);
    BuildManager__doGrant(buildMan);
  }
}

function BuildManager__doGrant(buildMan)
{
  var s = buildMan.sync;
  var filesToSync = buildMan.filesToSync;

  try
  {
    if (filesToSync != null && filesToSync.length)
    {
      var permMask = M1_DIR_ATTR_NETWORK | M1_DIR_ATTR_OPTICAL |
        M1_DIR_ATTR_REMOVABLE;
      
      var pendingGrants = new Array;

      for (i=0; i < filesToSync.length; i++)
      {
        pendingGrants.push(i);
      }
      
      // prevent completion until we have tried to sync everything!
      buildMan.pending[0] = 'grant';

      for (i=0; i < filesToSync.length; i++)
      { 
        var buildStatus = new Object;
        buildStatus.file = filesToSync[i];
        buildStatus.buildMan = buildMan;
        buildStatus.pendingGrants = pendingGrants;
        
        // can't change permissions on these mount types
        if ((filesToSync[i].data.attributes & permMask) == 0)
        {
          var path = ConvertMXURLtoPath(filesToSync[i].data.url);
          parent.objFrame.Toolbox.GrantReadAsync(path, 
                                                BuildManager__grantComplete, 
                                                buildStatus);
        }
        else
        {
          var comp = function(){
            BuildManager__grantComplete(0, true, buildStatus);
          }
          setTimeout(comp, 1);
        }
      }
    }
    else{
      BuildManager__complete(buildMan);
    }
  }
  catch(ex)
  {
    buildMan.stop();
    throw ex;
  }
}

function BuildManager__grantComplete(errorCode, result, buildStatus)
{
  var file = buildStatus.file;
  var buildMan = buildStatus.buildMan;
  var s = buildMan.sync;

  if (s.share(file.data))
  {
    var url = parent.objFrame.Toolbox.PathToUNC(file.data.url);
    url = (url == null) ? file.data.url : "file://" + url;

    buildMan.pending.push(url);
  }

  buildStatus.pendingGrants.pop();
  if (buildStatus.pendingGrants.length == 0){
    buildMan.pending.splice(0, 1);
    BuildManager__complete(buildMan);
  }
}

function BuildManager__complete(buildMan)
{
  var a = buildMan.agg;
  var serversToAgg = buildMan.serversToAgg;
  var serversToUnagg = buildMan.serversToUnagg;

  try
  {
    if (serversToUnagg != null)
    {
      for (i = 0; i < serversToUnagg.length; i++)
      {
        a.unaggregate(serversToUnagg[i].data);
        mxThrowIfFailed(a);
      }
    }

    if (serversToAgg != null)
    {
      for (i = 0; i < serversToAgg.length; i++)
      {
        a.aggregate(serversToAgg[i].data);
        mxThrowIfFailed(a);
        buildMan.pending.push(serversToAgg[i].data.identifier);
      }
    }

    if (!buildMan.pending.length)
    {
      if (buildMan.onComplete != null)
      {
        buildMan.stop();
        buildMan.onComplete(0, 0, 0, 0);
      }
    }
  }
  catch(ex)
  {
    buildMan.stop();
    throw ex;
  }
}

function BuildManager__progress(source, url, scanned, music, pictures, videos)
{
//alert('source=' + source + ';url=' + url + ';scanned=' + scanned + ';music=' + music +
//  ';pictures=' + pictures + ';videos=' + videos);

  // ensure events don't get after manager has been "stopped"
  if (!(this.synchronizing || this.aggregating))
    return;
   
  var isServer = (source == "IMXAggregator");
  url  = isServer ? url : NormalizePath(url);
  var i;
  for (i = 0; i < this.pending.length; i++)
  {
    var pending_url = isServer ? this.pending[i] : 
        NormalizePath(this.pending[i]);
    if (pending_url == url)
    {
      this.complete.push(url);
      this.pending.splice(i, 1);
      break;
    }
  }
  // this fixes count if we receive spurious events during aggregation or
  // externally invoked synchronization
  // if (scanned >= (music + pictures + videos))
  //{
    this.totalScanned += scanned;
    this.totalMusic  += music;
    this.totalPictures += pictures;
    this.totalVideos += videos;
    // }

  if (this.pending.length > 0)
  {
    if (this.onProgress != null)
    {
      this.onProgress(this.totalScanned, this.totalMusic, 
                      this.totalPictures, this.totalVideos);
    }
  }
  else
  {
    if (this.onComplete != null)
    {
      this.stop();
      this.onComplete(this.totalScanned, this.totalMusic, 
                      this.totalPictures, this.totalVideos);
    }
  }
}

function BuildManager__stop()
{
  if (this.synchronizing)
  {
    this.pageContext.objFrame.synchronizer.unnotifyChanges();
    this.synchronizing = false;
  }

  if (this.aggregating)
  {
    this.pageContext.objFrame.aggregator.unnotifyChanges();
    this.aggregating = false;
  }
}

/** NavigableItem object  **/
function NavigableItem()
{
}

NavigableItem.prototype.init = function(name, id, html, action, explore, data)
{
  this.name = name;
  this.id = id;
  this.html = html;
  this.action = action;
  this.explore = explore;
  this.data = data;
}

NavigableItem.prototype.dispose = function()
{
  // by default, do nothing
}

NavigableItem.prototype.getChildren = function(childList)
{
}

NavigableItem.prototype.isExplorable = function(pageContext)
{
  return false;
}

NavigableItem.prototype.isSelected = function(pageContext)
{
  return false;
}

function FileSystemItem()
{

}

FileSystemItem.prototype = new NavigableItem();

FileSystemItem.prototype.init = function(fileObject)
{
  NavigableItem.prototype.init.call(this, fileObject.name, fileObject.url, 
                                    null, null, null, fileObject);
  FileSystemItem.prototype.isFolder = true;
}

FileSystemItem.prototype.getChildren = function(childList)
{
  if (this.children == null)
  {
    this.children = new Array;
    var itr;
    try
    {
      itr = this.data.browse("*", 0);
    }
    catch(e)
    {
    }
    if (itr == null)
      return;
    var files = VBArray(itr.next(10000)).toArray();
    for (var i = 0; i < files.length; i++)
    {
      var item = new FileSystemItem();
      item.init(files[i]);
      this.children.push(item);
    }
  }
  for (var i = 0; i < this.children.length; i++)
  {
    childList.push(this.children[i]);
  }
}

FileSystemItem.prototype.getFolders = function(folderList)
{
  var fileItems = new Array;
  this.getChildren(fileItems);
  for (var i = 0; i < fileItems.length; i++)
  {
    if (fileItems[i].data.isFolder)
    {
      var val = fileItems[i].data.attributes & M1_DIR_ATTR_HIDDEN;
      if (!val)
        folderList.push(fileItems[i]);
    }
  }
}

FileSystemItem.prototype.markForSharing = function(pageContext, mark)
{
  var state = pageContext.objFrame.monitorState[this.id];
  if (!state)
  {
    state = new Object;
    state['pre'] = false;
    pageContext.objFrame.monitorState[this.id] = state;
  }
  state['post'] = mark;
}

FileSystemItem.prototype.isMarkedForSharing = function(pageContext)
{
  var state = pageContext.objFrame.monitorState[this.id];
  return (state != null  && state['post'] == true);
}

FileSystemItem.prototype.isExplorable = function(pageContext)
{
  var fileItems = new Array;
  this.getChildren(fileItems);
  for (var i = 0; i < fileItems.length; i++)
  {
    if (fileItems[i].data.isFolder)
    {
      var val = fileItems[i].data.attributes & M1_DIR_ATTR_HIDDEN;
      if (!val)	// just need one folder
        return true;
    }
  }
  return false;
}

FileSystemItem.prototype.isChangingShareState = function(pageContext)
{
  var state = pageContext.objFrame.monitorState[this.id];
  return (state != null) && (state['pre'] != state['post']);
}

function ServerItem()
{
}

ServerItem.prototype = new NavigableItem();

ServerItem.prototype.init = function(serverObject)
{
  NavigableItem.prototype.init.call(this, serverObject.name, serverObject.identifier,
                                    null, null, null, serverObject);
  ServerItem.prototype.isServer = true;
}

ServerItem.prototype.dispose = function()
{
  if (this.data)
  {
    this.data.dispose();
    this.data = null;
  }
}

ServerItem.prototype.markForSharing = function(pageContext, mark)
{
  var state = pageContext.objFrame.aggregateState[this.id];
  if (!state)
  {
    state = new Object;
    state['pre'] = false;
    pageContext.objFrame.monitorState[this.id] = state;
  }
  state['post'] = mark;
}

ServerItem.prototype.isMarkedForSharing = function(pageContext)
{
  var state = pageContext.objFrame.aggregateState[this.id];
  return (state != null  && state['post'] == true);
}

ServerItem.prototype.isChangingShareState = function(pageContext)
{
  var state = pageContext.objFrame.aggregateState[this.id];
  return (state != null) && (state['pre'] != state['post']);
}

/** DeviceManager object **/
function DeviceManager(pageContext)
{
  this.pageContext = pageContext;

  this.netXml = NetmapGetNetwork();
  this.netXml.setProperty("SelectionLanguage", "XPath");

  this.devices = new Array();

  var xmlDeviceNodes = this.netXml.selectNodes("/network/localhost");
  DeviceManager__initNetmap(this, xmlDeviceNodes);

  xmlDeviceNodes = this.netXml.selectNodes("/network/device");
  DeviceManager__initNetmap(this, xmlDeviceNodes);

  xmlDeviceNodes = GetAggregatedServerNodes(new Object);
  DeviceManager__initNetmap(this, xmlDeviceNodes);

  this.getAggregatedServers = DeviceManager__getAggregatedServers;
  this.getFolders = DeviceManager__getFolders;
  this.getRemoteFolders = DeviceManager__getRemoteFolders;
  this.getSharedFolders = DeviceManager__getSharedFolders;
  this.getSpecialFolders = DeviceManager__getSpecialFolders;
  this.getStandardSetupFolders = DeviceManager__getStandardSetupFolders;
  this.isDeviceIP = DeviceManager__isDeviceIP;
  this.isDeviceUrl = DeviceManager__isDeviceUrl;
  this.isLocalDevice = DeviceManager__isLocalDevice;
}

function DeviceManager__getAggregatedServers(deviceName, servers)
{
  // get the ip addresses for the specified url
  var device;
  var url;
  for (var i = 0; i < this.devices.length; i++)
  {
    if (deviceName == this.devices[i].name)
    {
      device = this.devices[i];
      break;
    }
  }
  var ipFilter;
  if (device)
      {
    ipFilter = new Array;
    for (var i = 0; i < device.adapter.length; i++)
    {
      ipFilter.push(device.adapter[i].ipv4);
    }
  }
  GetAggregatedServers(ipFilter, servers);
}

function DeviceManager__getFolders(path, folders)
{
  var itr;
  if (!path)
  {
    itr = this.pageContext.objFrame.fileServices.root;
  }
  else
  {
    var fileObj = this.pageContext.objFrame.fileServices.byURL(path);
    if (fileObj == null)
      return;
    itr = fileObj.browse("*", 0);
      fileObj = null;
  }
  if (itr == null)
    return;

  // get the list of folders and files.
  var fileObjs = VBArray(itr.next(10000)).toArray();
  for (var i = 0; i < fileObjs.length; i++)
  {
    if (fileObjs[i].isFolder)
    {
      var val =  fileObjs[i].attributes & M1_DIR_ATTR_HIDDEN;
      if (!val)	// not hidden
      {
        // special case: don't include special path "(Entire Network)"
        if (!path && fileObjs[i].name == "(Entire Network)")
          continue
        var item = new FileSystemItem();
        item.init(fileObjs[i]);
        folders.push(item);
      }
    }
  }
  itr = null; //cleanup
}

function DeviceManager__getRemoteFolders(folderList)
{
   for (var i=0; i< this.devices.length; i++)
   {
     if (this.devices[i].isRemote)
     {
       var fileObject = this.devices[i].fileObject;
       // if there isn't a file object, 
       // the device does not have shared folders
       if (!fileObject)
       {
         continue;
       }
       var itr = fileObject.browse("*", 0);
       if (itr == null)
           mxThrow(fileObject);
       
       var fileObjs = VBArray(itr.next(10000)).toArray();
       for (var j = 0; j < fileObjs.length; j++)
       {
  	 if (fileObjs[j].isFolder)
         {
           var item = new FileSystemItem();
           item.init(fileObjs[j]);
           folderList.push(item);
         }
       }
       itr = null;
     }
   }
}

function DeviceManager__getSharedFolders(folderList)
{
  var itr = this.pageContext.objFrame.synchronizer.monitors;
  if (itr == null)
    mxThrow(this.pageContext.objFrame.synchronizer);

  var monitors = VBArray(itr.next(10000)).toArray();
  mxThrowIfFailed(itr);
  for (var i = 0; i < monitors.length; i++)
  {
      var item = new FileSystemItem();
      item.init(monitors[i].fileSystemObject);
      folderList.push(item);
  }
}

function DeviceManager__getSpecialFolders(folderList)
{
  var paths = GetSpecialPaths();

  for(var i = 0; i < paths.length; i++)
  {
    var fileObj = this.pageContext.objFrame.fileServices.byURL(paths[i].location);
    if (fileObj)
    {
      var item = new FileSystemItem();
      item.init(fileObj);
      // If special path has a specific label, assign it as the displayed
      // item name.
      if (paths[i].label) {
	    if (paths[i].label != "") {
	      item.name = paths[i].label;
	    }
	  }
	  folderList.push(item);
      fileObj = null;
    }
  }
}

function DeviceManager__getStandardSetupFolders(folderList)
{
  var paths = GetStandardSetupPaths();

  for(var i = 0; i < paths.length; i++)
  {
    var fileObj = this.pageContext.objFrame.fileServices.byURL(paths[i].location);
    if (fileObj)
    {
      var item = new FileSystemItem();
      item.init(fileObj);
      folderList.push(item);
      fileObj = null;
    }
  }
}

function DeviceManager__isDeviceIP(device, ips)
{
  for (var i = 0; i < device.adapter.length; i++)
  {
    for (var j = 0; j < ips.length; j++)
    {
      if (ips[j].search(device.adapter[i].ipv4) != -1)
      {
        return true;
      }
    }
  }
  return false;
}

function DeviceManager__isDeviceUrl(deviceName, url)
{
  // check for drive based paths...
  if (url.substring(8, 9) == ":" &&
      this.isLocalDevice(deviceName))
  {
    return true;
  }
  if (url.substring(9, deviceName.length + 9).toLowerCase() == 
      deviceName.toLowerCase())
  {
    return true;
  }
  return false;
}

function DeviceManager__isLocalDevice(deviceName)
{
  for(var i = 0; i < this.devices.length; i++)
  {
    if (this.devices[i].name == deviceName)
      return !this.devices[i].isRemote;
  }
  return null;
}

function DeviceManager__initNetmap(devMan, xmlDeviceNodes)
{	
  for (var i=0; i<xmlDeviceNodes.length; i++)
  {
    var device = new Object();
    device.name = (xmlDeviceNodes.item(i).getElementsByTagName('name')).item(0).text;

    // find device in computer.
    var fileObj;
    if (xmlDeviceNodes.item(i).nodeName == 'localhost')
    {
      fileObj = devMan.pageContext.objFrame.fileServices.root;
      device.isRemote = false;
    }
    else
    {
      fileObj = devMan.pageContext.objFrame.fileServices.byURL("\\\\"+device.name);
      device.isRemote = true;
    }

    var friendly = (xmlDeviceNodes.item(i).getElementsByTagName('friendly')).item(0);
    if (friendly)
      device.friendly = friendly.text;
    else
      device.friendly = device.name;

    var agg = (xmlDeviceNodes.item(i).getElementsByTagName('aggregated')).item(0);
    if (agg)
      device.isAggregated = true;
    else
      device.isAggregated = false;

    var adapterElem = xmlDeviceNodes.item(i).getElementsByTagName('adapter');
    device.adapter = new Array;
    for (var j = 0; j < adapterElem.length; j++)
    {
      var adapterNode = adapterElem.nextNode;
      device.adapter[j] = new Object;
      device.adapter[j].ipv4 = (adapterNode.getElementsByTagName('ipv4')).item(0).text;
    }

    if (fileObj)
    {
      device.fileObject = fileObj;
    }

    device.checked = 0;
    devMan.devices.push(device);

    fileObj = null; // cleanup
  }
}

/** Tree Widget **/

function TreeNode()
{
}

TreeNode.prototype.init = function(tree, parent, content, 
                                   cbAction, cbChildren, cbFocus, cbUpdate, data)
{
  this.tree = tree;
  this.parent = parent;
  this.content = content;
  this.cbAction = cbAction;
  this.cbChildren = cbChildren;
  this.cbFocus = cbFocus;
  this.cbUpdate = cbUpdate;
  this.data = data;
  // track depth of node for formatting later
  this.depth = parent ? parent.depth + 1 : 0;
  // default to collapsed state;
  this.expanded = false;
  // default to unselected state;
  this.selected = false;
}

TreeNode.prototype.hasChildren = function()
{
  return (this.children && this.children.length);
}

TreeNode.prototype.isSelectable = function()
{
  return (this.cbAction && this.selected != 'parent');
}

TreeNode.prototype.isSelectNavigable = function()
{
  return (this.selected == 'parent' || this.isSelectable()); 
}

function CreateTreeControl(navParent, id, max)
{
  var tree = CreateGrid(navParent, id, max, 1, Tree__scroll);
  tree.elem.className = 'Tree';
  // hide the grid header
  tree.elem.tHead.style.display = 'none';

  for(var i = 0; i < max; i++)
  {
    var td = tree.navGrid[i][0];
    td.cbFocus = Tree__rowFocus;
    td.cbKeyStep = Tree__rowKeyStep;
  }

  tree.localCol = 0; // we'll track column navigation locally
  tree.children = new Array;
  tree.rows = new Array;
  tree.statsMessage = '';
  tree.statsLabel = '';

  tree.cbKeyStep = Tree__keyStep;

  return tree;
}

function CreateTreeNode(tree, parent, content, 
                        cbAction, cbChildren, cbFocus, cbUpdate, data)
{
  var node = new TreeNode();
  node.init(tree, parent, content, 
            cbAction, cbChildren, cbFocus, cbUpdate, data);
  return node;
}

function CreateTreeStats(tree, parentPane)
{
  tree.footer = CreateViewStats(parentPane, null, true).label;
  tree.breadcrumb = CreateWidget(parentPane, null, 'skip', 'div').elem;
  tree.breadcrumb.className = "ViewBreadcrumb";
}

function TreeExpandNode(tree, node, expand)
{
  if (node.expanded != expand)
  {
    node.expanded = expand;
    var row = Tree__updateNode(tree, node, node.treeRow);
    if (node.children)
    {
      // collapse should cascade to children
      if (!expand)
        Tree__collapseHelper(node);
      // update post siblings, our children may have overwritten them...
      row = Tree__updatePostSiblings(tree, node, row);
    }
    TreeSetViewport(tree, tree.viewFirst, 
                    row + 1, tree.viewCollapse);
  }
}

function TreeInsertRoots(tree, roots)
{
  for(var i = 0; i < roots.length; i++)
  {
    tree.children.push(roots[i]);
    Tree__updateNode(tree, roots[i], tree.rows.length);
  }
}

function TreeSelectNode(tree, node, selected)
{
  Tree__selectHelper(tree, node, selected);
  GridSetViewport(tree, tree.viewFirst, 
                  tree.viewTotal, tree.viewCollapse);
}

function TreeSetNodeHtml(tree, node, innerHtml)
{
  node.innerHtml = innerHtml;
}

function TreeSetNodeIcon(tree, node, iconClass)
{
  node.iconClass = iconClass;
}

function TreeSetStatsMessage(tree, str)
{
  tree.statsMessage = str;

  if (tree.footer)
  {
    tree.footer.innerHTML = tree.statsLabel;
    tree.breadcrumb.innerHTML = tree.statsMessage;
  }
}

function TreeSetViewport(tree, first, total, collapse)
{
  GridSetViewport(tree, first, tree.navCols * total, collapse);
}

function Tree__keyStep(tree, step, vert)
{
  if (vert && step > 0)
  {
    // allow vertical navigation to leave the end of the tree
    if (tree.viewFirst + tree.navRows*tree.navCols >= tree.viewTotal)
      return false;
  }
  if (GridKeyStep(tree, step, vert)) // default nav
  {
    if (widgetNavFocus && widgetNavFocus.navSkip){
        Tree__keyStep(tree, step, vert);
    }
    else
        WidgetSetFocus(widgetNavFocus); // ensure focus logic runs
    return true;
  }
  return false;
}

function Tree__rowFocus(td, focus)
{
  var tree = td.navTable;
  var node = tree.rows[tree.viewFirst + td.navRow];
  if (focus && node)
  {
    // prevent nav to non-existent check
    if (tree.localCol == 0 && !node.isSelectNavigable())
    {
      tree.localCol = 1;
    }
    else if (tree.localCol == 1 && 
             !(node.children && node.children.length))
    {
      tree.localCol = 0;
    }
    Tree__setRow(tree, node, td.navRow);
  }
  if (node && node.cbFocus)
  {
    node.cbFocus(tree, node, node.data, focus);
  }
  Tree__setScrollLabel(tree.viewFirst + td.navRow + 1, tree.viewTotal);
}

function Tree__rowKeyStep(td, step, vert)
{
  if (!vert)
  {
    var tree = td.navTable;
    var node = tree.rows[tree.viewFirst + td.navRow];
    // handle nav between columns
    if (step < 0 && tree.localCol == 1 && node.isSelectNavigable())
    {
      tree.localCol = 0;
      Tree__setRow(tree, node, td.navRow);
      return true;
    }
    else if (step > 0 && tree.localCol == 0 &&
             node.children && node.children.length)
    {
      tree.localCol = 1;
      Tree__setRow(tree, node, td.navRow);
      return true;
    }
  }
  return false;
}

function Tree__updatePostSiblings(tree, node, row)
{
  var siblings = node.parent ? node.parent.children : 
    tree.children;
  var updating = false;
  for(var i = 0; i < siblings.length; i++)
  {
    if (updating)
      row = Tree__updateNode(tree, siblings[i], row + 1);
    else
      updating = (siblings[i] == node);
  }
  // update our parent's post siblings...
  if (node.parent)
    row = Tree__updatePostSiblings(tree, node.parent, row);

  return row;
}

function Tree__updateNode(tree, node, row)
{
  tree.rows[row] = node;
  node.treeRow = row;

  if (!node.children && node.cbChildren)
  {
    node.children = new Array;
    node.cbChildren(tree, node, node.children, node.data);
    // ensure our selection state is consistent
    Tree__selectHelper2(tree, node, node.selected);
  }
  // if expanded, update children
  if (node.expanded)
  {
    for(var i = 0; i < node.children.length; i++)
    {
      row = Tree__updateNode(tree, node.children[i], row + 1);
    }
  }
  return row;
}

function Tree__mouseOverRow(row, localCol)
{
  /* WARNING...depends on global tree object being called "tree" */
  if (localCol != tree.localCol)
  {
    var node = tree.rows[tree.viewFirst + row];
    tree.localCol = localCol;
    Tree__setRow(tree, node, row);
  }
}

function Tree__setRow(tree, node, row)
{
  var hasChildren = node.hasChildren();
  var selected = (node.selected == true || node.selected == 'parent');

  var sel = tree.localCol == 0 ? 'Select' : '';
  var mouse = '';
  var cbox = 'style="width:40px; height:40px"'; // disabled
  if (node.isSelectable())
  {
    mouse = 'return Tree__mouseOverRow('+row+',0)';
    cbox = selected ? 'class="TreeCheckOn' + sel + '"' : 
      'class="TreeCheckOff' + sel + '"';
  }
  else if (node.cbAction)
  {
    mouse = 'return Tree__mouseOverRow('+row+',0)';
    cbox = selected ? 'class="TreeCheckOnInactive"' : 
      'class="TreeCheckOffInactive"';
  }

  var inner = '<span onmouseenter="' + mouse + '" ' + 
        cbox + '></span>';

  // calculate the available width for the node content
  var parentRect = tree.navParent.elem.getBoundingClientRect();
  var contentRect = tree.navGrid[row][0].elem.getBoundingClientRect();

  var content = node.content;
  if (node.cbUpdate)
    node.cbUpdate(tree, node, content, contentRect.right - contentRect.left);
 
  sel = tree.localCol == 1 ? 'Select"' : '"';
  var plus;
  if (node.expanded)
    plus = 'class="TreeMinus' + sel;
  else
    plus =  hasChildren ? 'class="TreePlus' + sel  : 
        'style="width:40px; height:40px"';
  mouse = hasChildren ? 'return Tree__mouseOverRow(' + row + ',1)' : '';
  inner += '<span onmouseenter="' + mouse + '" ' +
          plus + ' style="margin-left:' + (node.depth * 40 + 10) + '"></span>';
      
  inner += '<span class="' + node.iconClass + '" style="margin-left:10px"></span>' + 
      '<span style="padding-left:10px;vertical-align:middle">' + node.innerHtml + '</span>';

  GridSetCell(tree, row, 0, inner, Tree__action, null, node);
}

function Tree__scroll(tree, start, count)
{
  for (var i = 0; (tree.navCols * i) < count; i++)
  {
    var viewFirst = tree.viewFirst / tree.navCols;
    if (i + viewFirst < tree.rows.length)
    {
      var node = tree.rows[i + viewFirst];
      Tree__setRow(tree, node, i);
    }
    else
    {
      GridSetCell(tree, i, 0, '');
    }
  }

  Tree__setScrollLabel(tree.viewFirst + 1, tree.viewTotal); 
}

function Tree__action(cell, node)
{
  switch(tree.localCol)
  {
  case 0:
    if (node.isSelectable()) 
      Tree__select(cell, node);
    break;
  case 1:
    if (node.children && node.children.length) 
      Tree__expand(cell, node);
    break;
  }
}

function Tree__collapseHelper(node)
{
  node.expanded = false;
  if (node.children)
  {
    for(var i = 0; i < node.children.length; i++)
    {
      Tree__collapseHelper(node.children[i]);
    }      
  }
}

function Tree__expand(cell, node)
{
  TreeExpandNode(node.tree, node, !node.expanded);
}

function Tree__selectHelper(tree, node, state)
{
  if (node.selected == state)
    return;

  // save original state
  var old = node.selected;

  Tree__selectHelper2(tree, node, state);

  node.selected = state;
    
  // only fire event if "real" selection status has changed
  if (node.cbAction)
  {
    if ((old != true && state == true) || (old == true && state != true))
    {
      node.cbAction(tree, node, node.data, node.selected == true);
    }
  }
}

function Tree__selectHelper2(tree, node, state)
{
  if (state == true)
  {
    // when node is selected, children marked 'parent' state
    if (node.children)
    {
      for(var i = 0; i < node.children.length; i++)
      {
        Tree__selectHelper(tree, node.children[i], 'parent');
      }
    }
    // node's parent is marked 'child' state
    if (node.parent)
      Tree__selectHelper(tree, node.parent, 'child');
  }
  else if (state == false)
  {
    // if state is false, and parent is selected,
    // our other siblings should be selected
    if (node.selected == 'parent' && node.parent.selected != false)
    {
      // parent is de-selected
      Tree__selectHelper(tree, node.parent, false);

      for(var i = 0; i < node.parent.children.length; i++)
      {
        if (node.parent.children[i] != node)
        {
          Tree__selectHelper(tree, node.parent.children[i], true);
        }
      }
    }
    else if (node.selected == true || node.selected == 'parent')
    {
      if (node.children)
      {
        node.selected = false;
        //  we're being de-selected...this should cascade to children
        for(var i = 0; i < node.children.length; i++)
        {
          Tree__selectHelper(tree, node.children[i], false);
        }
      }
    }
    // when state is false, and our status is 'child',
    // recursion should terminate! (see above case)
  }
  else if (state == 'parent')
  {
    // when parent is selected, state cascades to children
    if (node.children)
    {
      for(var i = 0; i < node.children.length; i++)
      {
        Tree__selectHelper(tree, node.children[i], 'parent');
      }
    }
  }
  else if (state == 'child')
  {
    // when child is selected, cascade to parent
    if (node.parent)
      Tree__selectHelper(tree, node.parent, 'child');
  }
}

function Tree__select(cell, node)
{
  var selected = (node.selected == false || node.selected == 'child');
  TreeSelectNode(node.tree, node, selected);
}

function Tree__setScrollLabel(item, count)
{
  // TODO: L10N
  if (tree.footer)
  {
    tree.statsLabel = item + ' ' +
      context.getString('setup.connector.of') + ' ' + count;
    TreeSetStatsMessage(tree, tree.statsMessage);
  }
}

/**
    This is a Javascript implementation of the Java Hashtable object.
    
    Contructor(s):
     Hashtable()
              Creates a new, empty hashtable
    
    Method(s):
     void clear() 
              Clears this hashtable so that it contains no keys. 
     boolean containsKey(String key) 
              Tests if the specified object is a key in this hashtable. 
     boolean containsValue(Object value) 
              Returns true if this Hashtable maps one or more keys to this value. 
     Object get(String key) 
              Returns the value to which the specified key is mapped in this hashtable. 
     boolean isEmpty() 
              Tests if this hashtable maps no keys to values. 
     Array keys() 
              Returns an array of the keys in this hashtable. 
     void put(String key, Object value) 
              Maps the specified key to the specified value in this hashtable. A NullPointerException is thrown is the key or value is null.
     Object remove(String key) 
              Removes the key (and its corresponding value) from this hashtable. Returns the value of the key that was removed
     int size() 
              Returns the number of keys in this hashtable. 
     String toString() 
              Returns a string representation of this Hashtable object in the form of a set of entries, enclosed in braces and separated by the ASCII characters ", " (comma and space). 
     Array values() 
              Returns a array view of the values contained in this Hashtable. 
            
*/
function Hashtable(){
	try
	{	
    this.clear = hashtable_clear;
    this.containsKey = hashtable_containsKey;
    this.containsValue = hashtable_containsValue;
    this.get = hashtable_get;
    this.isEmpty = hashtable_isEmpty;
    this.keys = hashtable_keys;
    this.put = hashtable_put;
    this.remove = hashtable_remove;
    this.size = hashtable_size;
    this.toString = hashtable_toString;
    this.values = hashtable_values;
    this.hashtable = new Array();
	}
	catch(e)
	{
		alert('EXCEPTION: Hashtable()\n'+e.description);
	}
}                
/*=======Private methods for internal use only========*/

function hashtable_clear(){
	try
	{	
    this.hashtable = new Array();
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_clear()\n'+e.description);
	}
}

function hashtable_containsKey(key){
	try
	{	
    var exists = false;
    for (var i in this.hashtable) {
        if (i == key && this.hashtable[i] != null) {
            exists = true;
            break;
        }
    }
    return exists;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_containsKey('+key+')\n'+e.description);
	}
}

function hashtable_containsValue(value){
	try
	{	
    var contains = false;
    if (value != null) {
        for (var i in this.hashtable) {
            if (this.hashtable[i] == value) {
                contains = true;
                break;
            }
        }
    }
    return contains;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_containsValue('+value+')\n'+e.description);
	}
}

function hashtable_get(key){
	try
	{	
    return this.hashtable[key];
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_get('+key+')\n'+e.description);
	}
}

function hashtable_isEmpty(){
	try
	{	
    return (this.size == 0) ? true : false;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_isEmpty()\n'+e.description);
	}
}

function hashtable_keys(){
	try
	{	
    var keys = new Array();
    for (var i in this.hashtable) {
        if (this.hashtable[i] != null) 
            keys.push(i);
    }
    return keys;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_keys()\n'+e.description);
	}
}

function hashtable_put(key, value){
	try
	{	
    if (key == null || value == null) {
        throw "NullPointerException {" + key + "},{" + value + "}";
    }else{
        this.hashtable[key] = value;
    }
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_put('+key+', '+value+')\n'+e.description);
	}
}

function hashtable_remove(key){
	try
	{	
    var rtn = this.hashtable[key];
    this.hashtable[key] = null;
    return rtn;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_remove('+key+')\n'+e.description);
	}
}

function hashtable_size(){
	try
	{	
    var size = 0;
    for (var i in this.hashtable) {
        if (this.hashtable[i] != null) 
            size ++;
    }
    return size;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_size()\n'+e.description);
	}
}

function hashtable_toString(){
	try
	{	
    var result = "";
    for (var i in this.hashtable)
    {      
        if (this.hashtable[i] != null) 
            result += "{" + i + "},{" + this.hashtable[i] + "}\n";   
    }
    return result;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_toString()\n'+e.description);
	}
}

function hashtable_values(){
	try
	{	
    var values = new Array();
    for (var i in this.hashtable) {
        if (this.hashtable[i] != null) 
            values.push(this.hashtable[i]);
    }
    return values;
	}
	catch(e)
	{
		alert('EXCEPTION: hashtable_values()\n'+e.description);
	}
}
